	.org $c000

start:	jmp bounce

x1:	.word 0
y1:	.word 0
x2:	.word 0
y2:	.word 0

da:	.word 0
db:	.byte 0
dc:	.word 0
dd:	.byte 0


bounce:
	lda #0
	sta x1+1
	sta x2+1
	sta y1+1
	sta y2+1

	lda #10
	sta x1
	sta y1
	lda #21
	sta x2
	lda #34
	sta y2

	lda #2
	sta da
	sta dc

	lda #3
	sta dd

	lda #4
	sta db

inf:	jsr drwloop
	jmp inf

drwloop: jsr drawline

incry1:	lda y1
	clc
	adc db
	sta y1
	clc
	cmp #199
	bcc incry2

	lda db
	clc
	eor #$ff
	adc #1
	sta db
	jmp incry1

incry2:	lda y2
	clc
	adc dd
	sta y2
	clc
	cmp #199
	bcc incrx1

	lda dd
	clc
	eor #$ff
	adc #1
	sta dd
	jmp incry2

incrx1:	lda x1
	clc
	adc da
	sta x1
	lda x1+1
	adc da+1
	sta x1+1
	and #$81
	beq incrx2

	lda da
	eor #$ff
	clc
	adc #1
	sta da
	lda da+1
	eor #$ff
	adc #0
	sta da+1
	jmp incrx1

incrx2:	lda x2
	clc
	adc dc
	sta x2
	lda x2+1
	adc dc+1
	sta x2+1
	and #$81
	beq null

	lda dc
	eor #$ff
	clc
	adc #1
	sta dc
	lda dc+1
	eor #$ff
	adc #0
	sta dc+1
	jmp incrx2
	
null:	rts


plotx = $f000
ploty = $f002
plotdo = $f004

r5 = 242
r6 = 244
r7 = 246
r8 = 248
r9 = 250
ra = 252
rc = 254

drawline:
	lda #0
	sta rc
	sta rc+1
	sta r5+1
	sta r6+1

	lda #1
	sta r5
	sta r6

	lda x2
	sta r7
	lda x2+1
	sta r7+1

	lda x1
	sta r9
	lda x1+1
	sta r9+1

	lda r7
	sec
	sbc r9
	sta r7
	lda r7+1
	sbc r9+1
	sta r7+1
	
	and #128
	beq r7isplus

	lda #$ff
	sta r5
	sta r5+1
	
	lda r7
	eor #$ff
	clc
	adc #1
	sta r7
	lda r7+1
	eor #$ff
	adc #0
	sta r7+1

	jmp r8assign

r7isplus:
	lda r7+1
	bne r8assign
	lda r7
	bne r8assign

	lda #$80
	sta rc+1
	lda #0
	sta rc
	
r8assign:
	lda y2
	sta r8
	lda y2+1
	sta r8+1

	lda y1
	sta ra
	lda y1+1
	sta ra+1
	
	lda r8
	sec
	sbc ra
	sta r8
	lda r8+1
	sbc ra+1
	sta r8+1

	and #128
	beq loop
	
	lda #$ff
	sta r6
	sta r6+1
	
	lda r8
	eor #$ff
	clc
	adc #1
	sta r8
	lda r8+1
	eor #$ff
	adc #0
	sta r8+1

loop:
	lda r9
	sta plotx
	lda r9+1
	sta plotx+1
	lda ra
	sta ploty
	lda ra+1
	sta ploty+1

	lda #1
	sta plotdo

	clc
	lda x2
	cmp r9
	bne incline
	lda x2+1
	cmp r9+1
	bne incline

	lda y2
	cmp ra
	bne incline
	rts

incline:
	lda rc+1
	clc
	and #$80
	bne fixy

fixx:
	lda r9
	clc	
	adc r5
	sta r9
	lda r9+1
	adc r5+1
	sta r9+1
	
	lda rc
	sec
	sbc r8
	sta rc
	lda rc+1
	sbc r8+1
	sta rc+1
	jmp loop

fixy:
	lda ra
	clc
	adc r6
	sta ra

	lda rc
	clc
	adc r7
	sta rc
	lda rc+1
	adc r7+1
	sta rc+1
	jmp loop

