module decss(clk, rst, k, s, sp);

input clk; 
input rst; 
input [39:0] k; 
input [7:0] s; 
output [7:0] sp;

reg	[7:0]	kp0, kp1, sp;
reg	[6:0]	chk;
reg	[10:0]	n;
reg	[16:0]	l;
reg	[24:0]	m;
reg		xcarry, enc;

wire		lt128 = (n[10:7]==4'd0);
wire	[7:0]	kpin0=s[7:0]^k[39:32], kpin1=s[7:0]^k[31:24], kpin2=s[7:0]^k[23:16], kpin3=s[7:0]^k[15:8],kpin4=s[7:0]^k[7:0];
wire	[7:0]	lp=l[7:0]^{5'd0,l[16:14]}, mp=m[7:0]^m[10:3]^m[11:4]^m[19:12];
wire	[16:0]	lin={8'd0,l[16:8]}^{lp[7:0],9'd0}^{lp[4:0],12'd0}^{lp[1:0],15'd0};
wire	[24:0]	min={8'd0,m[24:8]}^{mp[7:0],17'd0};
wire	[8:0]	xin={1'b0,~lin[16:9]}+{1'b0,min[24:17]}+{8'd0,xcarry};
wire	[7:0]	p;
wire	[7:0]	spin = p[7:0] ^ xin[7:0];
		assign p[7:0] = {~((p[4]|p[5])^s[4]), ~((p[4]&p[5])^s[0]), ~((s[4]|s[5])^s[7]), ~((s[0]&s[1])^s[2]),
				 ~((p[0]&p[1])^s[1]), ~((p[0]&p[1])^s[5]), ~((s[4]&s[5])^s[6]), ~((s[0]&s[1])^s[3])};

always @(posedge clk)
	begin

	if(rst)
		begin
		n[10:0] <= 11'd0;
		chk[6:0] <= 7'h7f;
		end
		else
		begin
		n[10:0] <= n[10:0]+11'd1;

		if(lt128)
			begin
			xcarry <= 1'b0;

			if(n[6:0]==7'd84)
				kp0[7:0] <= {kpin0[0],kpin0[1],kpin0[2],kpin0[3],kpin0[4],kpin0[5],kpin0[6],kpin0[7]};
			else if(n[6:0]==7'd86)
				kp0[7:0] <= {kpin2[0],kpin2[1],kpin2[2],kpin2[3],kpin2[4],kpin2[5],kpin2[6],kpin2[7]};

			if(n[6:0]==7'd85)
				l[16:0] <= {kp0[7:0],1'b1,kpin1[0],kpin1[1],kpin1[2],kpin1[3],kpin1[4],kpin1[5],kpin1[6],kpin1[7]};

			if(n[6:0]==7'd87)
				kp1[7:0] <= {kpin3[0],kpin3[1],kpin3[2],kpin3[3],kpin3[4],kpin3[5],kpin3[6],kpin3[7]};

			if(n[6:0]==7'd88)
				m[24:0] <= {kp0[7:5],1'b1,kp0[4:0],kp1[7:0],kpin4[0],kpin4[1],kpin4[2],kpin4[3],kpin4[4],kpin4[5],kpin4[6],kpin4[7]};

			if(n[6:0]==7'd13)
				begin
				chk[6:0] <= {3'b001, s[2], ~s[2], s[1:0]};	// calc s[13]&7+20
				enc <= 1'b0;
				end
				else
				if(n[6:0]==chk[6:0])
					enc <= s[4];

			sp[7:0] <= {s[7:5], s[4] & (n[6:0]!=chk[6:0]), s[3:0]}; // clear encrypt flag if set

			end
		else
			begin
			if(enc)
				sp[7:0] <= spin[7:0];
				else
				sp[7:0] <= s[7:0];

			l[16:0] <= lin[16:0];
			m[24:0] <= min[24:0];
			xcarry  <= xin[8];
			chk[6] <= 1'b1;
			end
		end
	end

endmodule
