/* link this against circuit.c */

#include <stdio.h>
#include <fcntl.h>

void sim(void);
void sim_init(void);

int main(int argc, char **argv)
{
unsigned char s[24][2048];	/* room for 24 simultaneous enc sectors */
unsigned char k[5], kp=56;
int i, j;

sim_init();
t[57]=~0;			/* activate reset */
sim();

read(0, k, 5);
for(i=0;i<5;i++)
	{
	for(j=0;j<8;j++)
		{
		t[kp--] = ((k[i]>>(7-j)) & 1) ? ~0 : 0;	/* emit key to verilog model */
		}
	}

t[57]=0;			/* deassert reset */

for(;;)
{
int cnt, rc;

for(i=cnt=0;i<24;i++)
	{
	rc = read(0, s[i], 2048);
	if(!rc) break;
	cnt++;
	}
if(!cnt) break;

for(i=0;i<2048;i++)
	{
	/* join block */
	t[16] = ((s[0][i]>>7)&1) | ((s[1][i]>>6)&2) | ((s[2][i]>>5)&4) | ((s[3][i]>>4)&8) | ((s[4][i]>>3)&16) | ((s[5][i]>>2)&32) | ((s[6][i]>>1)&64) | ((s[7][i]>>0)&128) |
		(((s[8][i]>>7)&1)<<8) | (((s[9][i]>>6)&2)<<8) | (((s[10][i]>>5)&4)<<8) | (((s[11][i]>>4)&8)<<8) |
			(((s[12][i]>>3)&16)<<8) | (((s[13][i]>>2)&32)<<8) | (((s[14][i]>>1)&64)<<8) | (((s[15][i]>>0)&128)<<8) |
		(((s[16][i]>>7)&1)<<16) | (((s[17][i]>>6)&2)<<16) | (((s[18][i]>>5)&4)<<16) | (((s[19][i]>>4)&8)<<16) |
			(((s[20][i]>>3)&16)<<16) | (((s[21][i]>>2)&32)<<16) | (((s[22][i]>>1)&64)<<16) | (((s[23][i]>>0)&128)<<16);
 
	t[15] = ((s[0][i]>>6)&1) | ((s[1][i]>>5)&2) | ((s[2][i]>>4)&4) | ((s[3][i]>>3)&8) | ((s[4][i]>>2)&16) | ((s[5][i]>>1)&32) | ((s[6][i]>>0)&64) | ((s[7][i]<<1)&128) |
		(((s[8][i]>>6)&1)<<8) | (((s[9][i]>>5)&2)<<8) | (((s[10][i]>>4)&4)<<8) | (((s[11][i]>>3)&8)<<8) |
			(((s[12][i]>>2)&16)<<8) | (((s[13][i]>>1)&32)<<8) | (((s[14][i]>>0)&64)<<8) | (((s[15][i]<<1)&128)<<8) |
		(((s[16][i]>>6)&1)<<16) | (((s[17][i]>>5)&2)<<16) | (((s[18][i]>>4)&4)<<16) | (((s[19][i]>>3)&8)<<16) |
			(((s[20][i]>>2)&16)<<16) | (((s[21][i]>>1)&32)<<16) | (((s[22][i]>>0)&64)<<16) | (((s[23][i]<<1)&128)<<16);

	t[14] = ((s[0][i]>>5)&1) | ((s[1][i]>>4)&2) | ((s[2][i]>>3)&4) | ((s[3][i]>>2)&8) | ((s[4][i]>>1)&16) | ((s[5][i]>>0)&32) | ((s[6][i]<<1)&64) | ((s[7][i]<<2)&128) |
		(((s[8][i]>>5)&1)<<8) | (((s[9][i]>>4)&2)<<8) | (((s[10][i]>>3)&4)<<8) | (((s[11][i]>>2)&8)<<8) |
			(((s[12][i]>>1)&16)<<8) | (((s[13][i]>>0)&32)<<8) | (((s[14][i]<<1)&64)<<8) | (((s[15][i]<<2)&128)<<8) |
		(((s[16][i]>>5)&1)<<16) | (((s[17][i]>>4)&2)<<16) | (((s[18][i]>>3)&4)<<16) | (((s[19][i]>>2)&8)<<16) |
			(((s[20][i]>>1)&16)<<16) | (((s[21][i]>>0)&32)<<16) | (((s[22][i]<<1)&64)<<16) | (((s[23][i]<<2)&128)<<16);

	t[13] = ((s[0][i]>>4)&1) | ((s[1][i]>>3)&2) | ((s[2][i]>>2)&4) | ((s[3][i]>>1)&8) | ((s[4][i]>>0)&16) | ((s[5][i]<<1)&32) | ((s[6][i]<<2)&64) | ((s[7][i]<<3)&128) |
		(((s[8][i]>>4)&1)<<8) | (((s[9][i]>>3)&2)<<8) | (((s[10][i]>>2)&4)<<8) | (((s[11][i]>>1)&8)<<8) |
			(((s[12][i]>>0)&16)<<8) | (((s[13][i]<<1)&32)<<8) | (((s[14][i]<<2)&64)<<8) | (((s[15][i]<<3)&128)<<8) |
		(((s[16][i]>>4)&1)<<16) | (((s[17][i]>>3)&2)<<16) | (((s[18][i]>>2)&4)<<16) | (((s[19][i]>>1)&8)<<16) |
			(((s[20][i]>>0)&16)<<16) | (((s[21][i]<<1)&32)<<16) | (((s[22][i]<<2)&64)<<16) | (((s[23][i]<<3)&128)<<16);

	t[12] = ((s[0][i]>>3)&1) | ((s[1][i]>>2)&2) | ((s[2][i]>>1)&4) | ((s[3][i]>>0)&8) | ((s[4][i]<<1)&16) | ((s[5][i]<<2)&32) | ((s[6][i]<<3)&64) | ((s[7][i]<<4)&128) |
		(((s[8][i]>>3)&1)<<8) | (((s[9][i]>>2)&2)<<8) | (((s[10][i]>>1)&4)<<8) | (((s[11][i]>>0)&8)<<8) |
			(((s[12][i]<<1)&16)<<8) | (((s[13][i]<<2)&32)<<8) | (((s[14][i]<<3)&64)<<8) | (((s[15][i]<<4)&128)<<8) |
		(((s[16][i]>>3)&1)<<16) | (((s[17][i]>>2)&2)<<16) | (((s[18][i]>>1)&4)<<16) | (((s[19][i]>>0)&8)<<16) |
			(((s[20][i]<<1)&16)<<16) | (((s[21][i]<<2)&32)<<16) | (((s[22][i]<<3)&64)<<16) | (((s[23][i]<<4)&128)<<16);


	t[11] = ((s[0][i]>>2)&1) | ((s[1][i]>>1)&2) | ((s[2][i]>>0)&4) | ((s[3][i]<<1)&8) | ((s[4][i]<<2)&16) | ((s[5][i]<<3)&32) | ((s[6][i]<<4)&64) | ((s[7][i]<<5)&128) |
		(((s[8][i]>>2)&1)<<8) | (((s[9][i]>>1)&2)<<8) | (((s[10][i]>>0)&4)<<8) | (((s[11][i]<<1)&8)<<8) |
			(((s[12][i]<<2)&16)<<8) | (((s[13][i]<<3)&32)<<8) | (((s[14][i]<<4)&64)<<8) | (((s[15][i]<<5)&128)<<8) |
		(((s[16][i]>>2)&1)<<16) | (((s[17][i]>>1)&2)<<16) | (((s[18][i]>>0)&4)<<16) | (((s[19][i]<<1)&8)<<16) |
			(((s[20][i]<<2)&16)<<16) | (((s[21][i]<<3)&32)<<16) | (((s[22][i]<<4)&64)<<16) | (((s[23][i]<<5)&128)<<16);

	t[10] = ((s[0][i]>>1)&1) | ((s[1][i]>>0)&2) | ((s[2][i]<<1)&4) | ((s[3][i]<<2)&8) | ((s[4][i]<<3)&16) | ((s[5][i]<<4)&32) | ((s[6][i]<<5)&64) | ((s[7][i]<<6)&128) |
		(((s[8][i]>>1)&1)<<8) | (((s[9][i]>>0)&2)<<8) | (((s[10][i]<<1)&4)<<8) | (((s[11][i]<<2)&8)<<8) |
			(((s[12][i]<<3)&16)<<8) | (((s[13][i]<<4)&32)<<8) | (((s[14][i]<<5)&64)<<8) | (((s[15][i]<<6)&128)<<8) |
		(((s[16][i]>>1)&1)<<16) | (((s[17][i]>>0)&2)<<16) | (((s[18][i]<<1)&4)<<16) | (((s[19][i]<<2)&8)<<16) |
			(((s[20][i]<<3)&16)<<16) | (((s[21][i]<<4)&32)<<16) | (((s[22][i]<<5)&64)<<16) | (((s[23][i]<<6)&128)<<16);

	t[9]  = ((s[0][i]>>0)&1) | ((s[1][i]<<1)&2) | ((s[2][i]<<2)&4) | ((s[3][i]<<3)&8) | ((s[4][i]<<4)&16) | ((s[5][i]<<5)&32) | ((s[6][i]<<6)&64) | ((s[7][i]<<7)&128) |
		(((s[8][i]>>0)&1)<<8) | (((s[9][i]<<1)&2)<<8) | (((s[10][i]<<2)&4)<<8) | (((s[11][i]<<3)&8)<<8) |
			(((s[12][i]<<4)&16)<<8) | (((s[13][i]<<5)&32)<<8) | (((s[14][i]<<6)&64)<<8) | (((s[15][i]<<7)&128)<<8) |
		(((s[16][i]>>0)&1)<<16) | (((s[17][i]<<1)&2)<<16) | (((s[18][i]<<2)&4)<<16) | (((s[19][i]<<3)&8)<<16) |
			(((s[20][i]<<4)&16)<<16) | (((s[21][i]<<5)&32)<<16) | (((s[22][i]<<6)&64)<<16) | (((s[23][i]<<7)&128)<<16);
	sim();

	/* split block */
	s[0][i] = ((t[8]&1)<<7)|((t[7]&1)<<6)|((t[6]&1)<<5)|((t[5]&1)<<4)|((t[4]&1)<<3)|((t[3]&1)<<2)|((t[2]&1)<<1)|((t[1]&1)<<0);
	s[1][i] = ((t[8]&2)<<6)|((t[7]&2)<<5)|((t[6]&2)<<4)|((t[5]&2)<<3)|((t[4]&2)<<2)|((t[3]&2)<<1)|((t[2]&2)<<0)|((t[1]&2)>>1);
	s[2][i] = ((t[8]&4)<<5)|((t[7]&4)<<4)|((t[6]&4)<<3)|((t[5]&4)<<2)|((t[4]&4)<<1)|((t[3]&4)<<0)|((t[2]&4)>>1)|((t[1]&4)>>2);
	s[3][i] = ((t[8]&8)<<4)|((t[7]&8)<<3)|((t[6]&8)<<2)|((t[5]&8)<<1)|((t[4]&8)<<0)|((t[3]&8)>>1)|((t[2]&8)>>2)|((t[1]&8)>>3);
	s[4][i] = ((t[8]&16)<<3)|((t[7]&16)<<2)|((t[6]&16)<<1)|((t[5]&16)<<0)|((t[4]&16)>>1)|((t[3]&16)>>2)|((t[2]&16)>>3)|((t[1]&16)>>4);
	s[5][i] = ((t[8]&32)<<2)|((t[7]&32)<<1)|((t[6]&32)<<0)|((t[5]&32)>>1)|((t[4]&32)>>2)|((t[3]&32)>>3)|((t[2]&32)>>4)|((t[1]&32)>>5);
	s[6][i] = ((t[8]&64)<<1)|((t[7]&64)<<0)|((t[6]&64)>>1)|((t[5]&64)>>2)|((t[4]&64)>>3)|((t[3]&64)>>4)|((t[2]&64)>>5)|((t[1]&64)>>6);
	s[7][i] = ((t[8]&128)<<0)|((t[7]&128)>>1)|((t[6]&128)>>2)|((t[5]&128)>>3)|((t[4]&128)>>4)|((t[3]&128)>>5)|((t[2]&128)>>6)|((t[1]&128)>>7);
	s[8][i] = (((t[8]>>8)&1)<<7)|(((t[7]>>8)&1)<<6)|(((t[6]>>8)&1)<<5)|(((t[5]>>8)&1)<<4)|(((t[4]>>8)&1)<<3)|(((t[3]>>8)&1)<<2)|(((t[2]>>8)&1)<<1)|(((t[1]>>8)&1)<<0);
	s[9][i] = ((t[8]>>8&2)<<6)|(((t[7]>>8)&2)<<5)|(((t[6]>>8)&2)<<4)|(((t[5]>>8)&2)<<3)|(((t[4]>>8)&2)<<2)|(((t[3]>>8)&2)<<1)|(((t[2]>>8)&2)<<0)|(((t[1]>>8)&2)>>1);
	s[10][i] = (((t[8]>>8)&4)<<5)|(((t[7]>>8)&4)<<4)|(((t[6]>>8)&4)<<3)|(((t[5]>>8)&4)<<2)|(((t[4]>>8)&4)<<1)|(((t[3]>>8)&4)<<0)|(((t[2]>>8)&4)>>1)|(((t[1]>>8)&4)>>2);
	s[11][i] = (((t[8]>>8)&8)<<4)|(((t[7]>>8)&8)<<3)|(((t[6]>>8)&8)<<2)|(((t[5]>>8)&8)<<1)|(((t[4]>>8)&8)<<0)|(((t[3]>>8)&8)>>1)|(((t[2]>>8)&8)>>2)|(((t[1]>>8)&8)>>3);
	s[12][i] = (((t[8]>>8)&16)<<3)|(((t[7]>>8)&16)<<2)|(((t[6]>>8)&16)<<1)|(((t[5]>>8)&16)<<0)|(((t[4]>>8)&16)>>1)|(((t[3]>>8)&16)>>2)|(((t[2]>>8)&16)>>3)|(((t[1]>>8)&16)>>4);
	s[13][i] = ((t[8]>>8&32)<<2)|(((t[7]>>8)&32)<<1)|(((t[6]>>8)&32)<<0)|(((t[5]>>8)&32)>>1)|(((t[4]>>8)&32)>>2)|(((t[3]>>8)&32)>>3)|(((t[2]>>8)&32)>>4)|(((t[1]>>8)&32)>>5);
	s[14][i] = (((t[8]>>8)&64)<<1)|(((t[7]>>8)&64)<<0)|(((t[6]>>8)&64)>>1)|(((t[5]>>8)&64)>>2)|(((t[4]>>8)&64)>>3)|(((t[3]>>8)&64)>>4)|(((t[2]>>8)&64)>>5)|(((t[1]>>8)&64)>>6);
	s[15][i] = (((t[8]>>8)&128)<<0)|(((t[7]>>8)&128)>>1)|(((t[6]>>8)&128)>>2)|(((t[5]>>8)&128)>>3)|(((t[4]>>8)&128)>>4)|(((t[3]>>8)&128)>>5)|(((t[2]>>8)&128)>>6)|(((t[1]>>8)&128)>>7);
	s[16][i] = (((t[8]>>16)&1)<<7)|(((t[7]>>16)&1)<<6)|(((t[6]>>16)&1)<<5)|(((t[5]>>16)&1)<<4)|(((t[4]>>16)&1)<<3)|(((t[3]>>16)&1)<<2)|(((t[2]>>16)&1)<<1)|(((t[1]>>16)&1)<<0);
	s[17][i] = ((t[8]>>16&2)<<6)|(((t[7]>>16)&2)<<5)|(((t[6]>>16)&2)<<4)|(((t[5]>>16)&2)<<3)|(((t[4]>>16)&2)<<2)|(((t[3]>>16)&2)<<1)|(((t[2]>>16)&2)<<0)|(((t[1]>>16)&2)>>1);
	s[18][i] = (((t[8]>>16)&4)<<5)|(((t[7]>>16)&4)<<4)|(((t[6]>>16)&4)<<3)|(((t[5]>>16)&4)<<2)|(((t[4]>>16)&4)<<1)|(((t[3]>>16)&4)<<0)|(((t[2]>>16)&4)>>1)|(((t[1]>>16)&4)>>2);
	s[19][i] = (((t[8]>>16)&8)<<4)|(((t[7]>>16)&8)<<3)|(((t[6]>>16)&8)<<2)|(((t[5]>>16)&8)<<1)|(((t[4]>>16)&8)<<0)|(((t[3]>>16)&8)>>1)|(((t[2]>>16)&8)>>2)|(((t[1]>>16)&8)>>3);
	s[20][i] = (((t[8]>>16)&16)<<3)|(((t[7]>>16)&16)<<2)|(((t[6]>>16)&16)<<1)|(((t[5]>>16)&16)<<0)|(((t[4]>>16)&16)>>1)|(((t[3]>>16)&16)>>2)|(((t[2]>>16)&16)>>3)|(((t[1]>>16)&16)>>4);
	s[21][i] = ((t[8]>>16&32)<<2)|(((t[7]>>16)&32)<<1)|(((t[6]>>16)&32)<<0)|(((t[5]>>16)&32)>>1)|(((t[4]>>16)&32)>>2)|(((t[3]>>16)&32)>>3)|(((t[2]>>16)&32)>>4)|(((t[1]>>16)&32)>>5);
	s[22][i] = (((t[8]>>16)&64)<<1)|(((t[7]>>16)&64)<<0)|(((t[6]>>16)&64)>>1)|(((t[5]>>16)&64)>>2)|(((t[4]>>16)&64)>>3)|(((t[3]>>16)&64)>>4)|(((t[2]>>16)&64)>>5)|(((t[1]>>16)&64)>>6);
	s[23][i] = (((t[8]>>16)&128)<<0)|(((t[7]>>16)&128)>>1)|(((t[6]>>16)&128)>>2)|(((t[5]>>16)&128)>>3)|(((t[4]>>16)&128)>>4)|(((t[3]>>16)&128)>>5)|(((t[2]>>16)&128)>>6)|(((t[1]>>16)&128)>>7);
	}

for(i=0;i<cnt;i++)
	{
	write(1, s[i], 2048);
	}
if(cnt<24) break;
}

exit(0);
}
