#include <stdio.h>
#include <stdlib.h>
#include "csim.h"

int generate_vcd=1;
FILE *vcdfd=NULL;

int cycle=0;
char force_node_init_value='X';

void Clock(int howmany)
{
SimulateModel(howmany);
}

void tick(void)
{
Clock(1);

if(generate_vcd)
	{
	WriteVCDFrame(vcdfd, cycle);
	}

cycle++;
}

void init(void)
{
int i;

InitializeModelValue(force_node_init_value);
if(!ImportModel("dff.csim"))
	{
	exit(255);
	}


if(generate_vcd)
	{
	SetVCDtmpsigMode(1);
	vcdfd=OpenVCD("dff.vcd");
	}

SetSimClockMode(0);
SetGetFacMode(0);	/* fine for this example, but normally should be (1) */
}


int main(int argc, char **argv)
{
int i;

atexit((void(*)(void))UnloadModel);
init();

StkFacName(0, "dff/r",0,0);
StkFacName(0, "dff/s",0,0);
StkFacName(0, "dff/d",0,0);
StkFacName(0, "dff/clk",0,0);
tick();
tick();

StkFacName(1, "dff/d",0,0);
StkFacName(0, "dff/clk",0,0);
tick();
StkFacName(1, "dff/clk",0,0);
tick();

StkFacName(0, "dff/clk",0,0);
tick();
StkFacName(0, "dff/d",0,0);
StkFacName(1, "dff/clk",0,0);
tick();

StkFacName(0, "dff/clk",0,0);
tick();
StkFacName(1, "dff/d",0,0);
StkFacName(1, "dff/clk",0,0);
tick();

tick();
tick();
tick();
StkFacName(1, "dff/r",0,0);
tick();
StkFacName(0, "dff/r",0,0);
tick();
StkFacName(1, "dff/s",0,0);
tick();
StkFacName(0, "dff/s",0,0);
tick();
StkFacName(1, "dff/r",0,0);
StkFacName(1, "dff/s",0,0);
tick();
StkFacName(0, "dff/r",0,0);
StkFacName(0, "dff/s",0,0);
tick();

tick();
tick();
tick();
tick();

StkFacName(0, "dff/clk",0,0);
tick();
tick();
tick();
StkFacName(1, "dff/r",0,0);
tick();
StkFacName(0, "dff/r",0,0);
tick();
StkFacName(1, "dff/s",0,0);
tick();
StkFacName(0, "dff/s",0,0);
tick();
StkFacName(1, "dff/r",0,0);
StkFacName(1, "dff/s",0,0);
tick();
StkFacName(0, "dff/r",0,0);
StkFacName(0, "dff/s",0,0);
tick();
tick();
tick();
tick();
tick();
tick();

if(vcdfd)
	{
	CloseVCD(vcdfd);
	}

exit(0);
}

