#include <stdio.h>
#include <stdlib.h>
#include "csim.h"

int cycle=0;
int ignore_clocks=0;
char force_node_init_value='0';


void init(void)
{
int i;

InitializeModelValue(force_node_init_value);
if(!ImportModel("circuit.csim"))
	{
	exit(255);
	}

SetSimClockMode(ignore_clocks);
SetGetFacMode(1);	/* autoeval if model dirty */
}


int main(int argc, char **argv)
{
int i, j, k, l, c;
signed char j1, j2;

atexit((void(*)(void))UnloadModel);
init();

for(i=0;i<256;i++)
{
StkFacName(i, "test/a",7,0);
j2=GetFacName("test/n",7,0);
j1=(signed char)i;
printf("                 \ra: %-3d, n: %-3d\r",j1,j2);
if((j1!=-j2)&&(j1!=-128)) { printf("\nError!\n"); exit(0); }
}
printf("\nNegation Passed...\n");


for(i=0;i<256;i++)
for(j=0;j<8;j++)
	{
	StkFacName(i, "test/i",7,0);
	StkFacName(j, "test/shift",2,0);
	k=GetFacName("test/o",7,0);
	l=(((i<<8)|(i))>>(8-j))&0xff;
	printf("                                        \ri: %d, shift:%d, o:%d, exp: %d\r",i,j,k,l); 
	if(k!=l) { printf("\nError!\n"); exit(0); }
	}

printf("\nBarrel Shifter Passed...\n");


for(i=0;i<256;i++)
for(j=0;j<256;j++)
	{
	StkFacName(i, "test/a",15,0);
	StkFacName(j, "test/b",15,0);
	k=GetFacName("test/p",15,0);
	l=GetFacName("test/m",15,0);
	printf("                                        \ra: %d, b:%d, p:%d, m: %d, m+p: %d\r",i,j,k,l, (k+l)&65535); 
	if(i+j!=k) { printf("\nError!\n"); exit(0); }
	if(((i-j)&65535)!=l) { printf("\nError!\n"); exit(0); } 

	c=GetFacName("test/chk",0,0);
	if(c) printf("\n...found chk: (a=42, b=142)\n");

	c=GetFacName("test/chk2",0,0);
	if(c) printf("\n...found chk2: (p==16'd508 || m+p==16'd146 && p==16'd322)\n");

	}
printf("\nAddition/Subtraction Passed...\n");

exit(0);
}
