#include "aet.h"
#include "mem.h"

extern int InitDisplay(char *, char *);
extern void InitTimes(int, int, int);
extern void DisplayTraces( int );

Ulong max_time=0;
long  min_time=-1;

int main(int argc, char **argv)
{
char str[1024];
struct symbol *s;
char *fname=NULL;
char *wname=NULL;
int i,flag;
FILE *wave;

if((argc<2)||(argc>3))
	{
	printf("Usage:\n%s aetfile.aet [signalfile.wav]\n\n",argv[0]);
	printf( "Format of .wav file lines (also for \"window/add trace\" strings:\n"
		"Aliases: +aliasname  signaltoalias\n"
		"Vectors: #vectorname signalstovector [signalstovector] [...]\n"
		"Signals: signalorsignals [signalorsignals] [...]\n\n"
		"To specify >1 signal in a declaration (except +) use \"*\"s for wildcards.\n"
		"See the accompanying documentation for more information.\n\n");
	exit(0);
	}

printf("\nAnna: Wave Analyzer v1.0.0 (w)1999 BSI\n\n");

sym=(struct symbol **)Vcalloc(SYMPRIME,sizeof(struct symbol *));

max_time=aet(fname=argv[1]);

InitDisplay(fname,NULL); /* was formerly :0.0 for 2nd arg which caused
				problems on remote displays */

tims.first=(Ulong)min_time;
tims.last=max_time;
tims.start=(Ulong)min_time;
tims.steps=max_time-min_time;
tims.end=max_time;
tims.cursor=(Ulong)min_time;

DisplayTraces(0);

if(argc==3)
if(!(wave=fopen(wname=argv[2],"rb")))
	{
	printf("Error opening .wav file '%s'.\n",wname);
	exit(0);
	}
	else
	{
	char iline[1024];

	while(fgets(iline,1024,wave))
		{
		parsewavline(iline);
		}
	fclose(wave);
	}

DisplayTraces(1);

while(1)	/* infinite loop...ctrl c to exit the program.. */
	{
	pause();
	}

return(0);
}

