/* 
 * Copyright (c) Tony Bybell 1999.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef CSIM_INTERNAL_H
#define CSIM_INTERNAL_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "alloca.h"
#include "csim.h"
#include "lxt_write.h"

#define CSIM "# CSIMINFO   "

typedef union{int i;void *pnt;} Opcode;

enum SymAttribs
{
SYM_STKFAC_B, SYM_IN_B, SYM_OUT_B, SYM_WIRE_B, SYM_REG_B, SYM_CONST_B, SYM_TMPSIG_B, SYM_ALIAS_B
};

#define SYM_STKFAC (1<<SYM_STKFAC_B)
#define SYM_IN     (1<<SYM_IN_B)
#define SYM_OUT    (1<<SYM_OUT_B)
#define SYM_WIRE   (1<<SYM_WIRE_B)
#define SYM_REG    (1<<SYM_REG_B)
#define SYM_CONST  (1<<SYM_CONST_B)
#define SYM_TMPSIG (1<<SYM_TMPSIG_B)
#define SYM_ALIAS  (1<<SYM_ALIAS_B)

struct fac
{
union
{
struct fac *alias;
struct
	{
	char real_value;
	char latch_value;       /* for latches only */
	char prev_clock;        /* for latches only */
	} v;
}u;

char *name;
struct lt_symbol *lxtsymbol;
unsigned char attributes;

};


struct vcd
{
char identifier[7];
char prevval;
};

#endif

