/* 
 * Copyright (c) Tony Bybell 1999.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */


#ifndef ED_MAIN_H
#define ED_MAIN_H

#include <stdio.h>
#include <curses.h>
#include <signal.h>
#include <errno.h>

struct line
{
struct line *next;
struct line *prev;
int len;
int offset;
char dirty;
char *str;
};

extern short maxx, maxy;
extern struct line *textroot;
extern struct line *readend, *textend;
extern struct line *topline;
extern struct line *curline;
extern int current_line_base, current_line_row, current_line_col;
extern int total_lines;

void ed_status_bar(void);
void ed_draw_line(short i, struct line *pos, short mx, short my, int offset);
void ed_refresh_screen(void);
struct line *ed_read_file(char *name, struct line *inspos);


#endif
