/* Copyright (C) 1996 Himanshu M. Thaker

This file is part of vpp.

Vpp is distributed in the hope that it will be useful,
but without any warranty.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.

Everyone is granted permission to copy, modify and redistribute
vpp, but only under the conditions described in the
document "vpp copying permission notice".   An exact copy
of the document is supposed to have been given to you along with
vpp so that you can know how you may redistribute it all.
It should be in a file named COPYING.  Among other things, the
copyright notice and this notice must be preserved on all copies.  */

/*
 * $Header: /home/cvspsrv/cvsroot/eda/vbpp/vpp.c,v 1.2 2001/01/25 07:38:03 jching Exp $
 * Program :
 * Author : Himanshu M. Thaker
 * Date : Apr. 16, 1995
 * Description :
 * $Log: vpp.c,v $
 * Revision 1.2  2001/01/25 07:38:03  jching
 * Return non-zero when parsing error detected.
 *
 * Revision 1.1.1.1  2000/02/21 04:05:37  ahvezda
 * Import of vbpp
 *
 * Revision 1.3  1995/04/21  18:11:58  hemi
 * *** empty log message ***
 *
 * Revision 1.3  1995/04/21  18:11:58  hemi
 * *** empty log message ***
 *
 * Revision 1.2  1995/04/18  00:23:43  hemi
 * *** empty log message ***
 *
 * Revision 1.1  1995/04/16  19:38:15  hemi
 * Initial revision
 */


/*
 * include files...
 */
#include "vpp_common.h"
#include "vpp_yacc_stuff.h"
#include <stdio.h>
#include <string.h>

static char *stdin_name="<stdin>";
struct preproc_buff_t *preproc_buff_head=NULL, *preproc_buff_current=NULL;
extern int vppcommentdepth;

/*
 * printf to memory..
 */
int mprintf(const char *fmt, ... )
{
int rc;
va_list args;
struct preproc_buff_t *bt = (struct preproc_buff_t *)calloc(1, sizeof(struct preproc_buff_t));
char buff[65537];

va_start(args, fmt);
rc=vsprintf(buff, fmt, args);
bt->len = strlen(buff);
bt->str = malloc(bt->len+1);
strcpy(bt->str, buff);

if(!preproc_buff_current)
	{
	preproc_buff_head = preproc_buff_current = bt;
	}
	else
	{
	preproc_buff_current->next = bt;
	preproc_buff_current = bt;	
	}

return(rc);
}

/*
 * get maxsiz chars from memory and copy into buf
 * (return actual number of characters copied)
 */
int mgetstr(char *buf, int maxsiz)
{
struct preproc_buff_t *bt = preproc_buff_head;
int cpylen;

if(!bt) return(0);

cpylen = bt->len-bt->pos;
if(cpylen <= maxsiz)
	{
	memcpy(buf, bt->str + bt->pos, cpylen);
	free(bt->str);

	if(bt != preproc_buff_current)
		{
		preproc_buff_head = bt->next;
		}
		else
		{
		preproc_buff_head = preproc_buff_current = NULL;
		}
	free(bt);
	}
	else
	{
	memcpy(buf, bt->str + bt->pos, maxsiz);
	bt->pos += (cpylen=maxsiz);
	}

return(cpylen);
}

int mgetbuf(char *buf, int maxsiz)
{
int total=0, rc;

do
	{
	total+=(rc=mgetstr(buf+total, maxsiz-total));
	} while((rc!=0)&&(total!=maxsiz));

return(total);
}


int vpp_main(FILE *f, const char *name)
{
static int banner=0;

if(!banner)
	{
	banner=1;
	fprintf(stderr, "VPP: Verilog Preprocessor 1.0.4-6 Copyright (C) 1996 Himanshu M. Thaker\n\n");
	}

nl_count = 1;
if(current_file) free(current_file);
current_file = malloc(strlen(name)+1);
strcpy(current_file, name);
do_comment_count(1,nl_count);
wwin=f;
wwparse();

if(vppcommentdepth)
        {
        vppcommentdepth=0;
        wwerror_count++;        /* to stop further preprocessing.. */
        }

return(wwerror_count);
}
