
/************************************************************
**
**       COPYRIGHT (C) 1988 UNIVERSITY OF PITTSBURGH
**                  ALL RIGHTS RESERVED
**
**        This software is distributed on an as-is basis
**        with no warranty implied or intended.  No author
**        or distributor takes responsibility to anyone 
**        regarding its use of or suitability.
**
**        The software may be distributed and modified 
**        freely for academic and other non-commercial
**        use but may NOT be utilized or included in whole
**        or part within any commercial product.
**
**        This copyright notice must remain on all copies 
**        and modified versions of this software.
**
************************************************************/

/*
**   File:        util.c
**
**   Functions:   lprintf, verror
**
**   Description:
**
**
**   Author:      Lyn Ann Mears    (LAM) - University of Pittsburgh, EE Dept.
**   Modified by: Alan R. Martello (ARM) - University of Pittsburgh, EE Dept.
**
**   Revision History
**   ----------------
**   Date      Initials   Description of change
**
**   thru 7/88   LAM      Initial modification of RSIM along with writing
**                        new routines, including debug of code.
**   08/04/88    ARM      Code cleanup; added comments.
**
**
**   Some code taken and adapted from RSIM work performed by Chris Terman.
**
*/

#include "net.h"

/* print value of specific node */
int             column;
FILE           *logfile = NULL;	/* logfile for all transactions 	 */
char           *filename;	/* current input file 			 */

/*VARARGS*/
/*ARGSUSED*/
lprintf (out, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t)
    FILE           *out;
    char           *a;
{
    static int found_newline = TRUE;
    char *c_ptr;

    fprintf (out, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t);

    if (logfile)
    {
	/* comment out every line logged for later replay  */
        if (found_newline == TRUE)
        {
            fprintf (logfile, "|  ");
            found_newline = FALSE;
        }

        /*  output the information  */
	fprintf (logfile, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t);

        /*  scan the input for a newline  */
        for (c_ptr = a; *c_ptr != '\0'; c_ptr++)
        {
            if (*c_ptr == '\n')
            {
                found_newline = TRUE;
                break;
            }
        }
    }
}

/*VARARGS*/
/*ARGSUSED*/
verror (a, b, c, d, e, f, g)
    char           *a;
{
    lprintf (stderr, "(%s,%d): ", filename, lineno);
    lprintf (stderr, a, b, c, d, e, f, g);
    fflush (stderr);
}
