//
// MIPS Pipelined House O Horrors...
//
module exercise(newpc,freeze);
reg [15:0] pc;
output [15:0] newpc;
output freeze;
reg clk;
reg [15:0] i;
reg MEMDEBUG, REGDEBUG;

datapath dp(clk, pc,newpc,freeze,MEMDEBUG,REGDEBUG);

initial
begin

#0	pc=0; 
#60	clk=1; $display("UPCLOCK"); REGDEBUG=0; #0 REGDEBUG=1; //  MEMDEBUG=0; #0 MEMDEBUG=1;

for(i=0;i<7;i=i+1)
begin
#60	clk=0;
#60	clk=1; $display("UPCLOCK"); REGDEBUG=0; #0 REGDEBUG=1; #0 MEMDEBUG=0; #0 MEMDEBUG=1;
end

#1000	$display("");
#2000 $finish;
end

always			// pc loader behavorial desc..
begin			// should really be in the datapath, but it
 @(posedge clk)		// doesn't really matter..
#100 pc=newpc;
$display("newpc: %h",newpc);
end

endmodule

//
// alu input mux for data forwarding
//
module alumux(val, sel, in0, in1, in2);

input [1:0] sel;
input [15:0] in0, in1, in2;
output [15:0] val;
reg [15:0] val;

initial
begin
#0 val=16'h0000;  // so no x's propagate through the alu muxes.
end

always
#1
begin
if(sel==2'b00) val=in0;
if(sel==2'b01) val=in1;
if(sel==2'b10) val=in2;
end
endmodule

//
// forwarding module
//
module forward(alusela, aluselb, idexrr1, idexrr2, idexwr, exmemwr, memwbwr, exmemregwrite, memwbregwrite,exmemrt);

output [1:0] alusela, aluselb;
reg    [1:0] alusela, aluselb;

input  [2:0] idexrr1, idexrr2, idexwr, exmemwr, memwbwr,exmemrt;
input  exmemregwrite, memwbregwrite; 

always
#5
begin

if ((exmemregwrite==1)&&(exmemwr!=0)&&(exmemwr==idexrr1)) alusela=01; else
if ((memwbregwrite==1)&&(memwbwr==idexrr1)) alusela=2'b10; else
alusela=2'b00;

if ((exmemregwrite==1)&&(exmemwr!=0)&&(exmemwr==idexrr2)) aluselb=01; else
if ((memwbregwrite==1)&&(memwbwr==idexrr2)) aluselb=2'b10; else
aluselb=2'b00;

end
endmodule


//
// hazard detection on lw...generates freeze signal for pipes
//
module lwhaz(freeze,idexinst,idexrs,ifidrs,ifidrt);
output freeze;
reg freeze;
input [2:0] idexinst,idexrs,ifidrs,ifidrt;

initial
begin
#0 freeze=0;
end

always
begin
#5
if ((idexinst==3'b011)&&((idexrs==ifidrs)||(idexrs==ifidrt)))
freeze=1;
else freeze=0;
end

always
begin
@(freeze)
if(freeze==1) $display("STALL idexrs: %h ifidrs %h ifidrt %h",idexrs,ifidrs,ifidrt);
if(freeze==0) $display("FREEZE cleared");
end

endmodule

// ----------------------------------------------------------------------------
// pipeline registers...
// ----------------------------------------------------------------------------
module pipeifid(clk, pc, pcout, ir, irout,freeze,exflush);
input clk,freeze;
input [15:0] pc;
input [15:0] ir;
input exflush;
output [15:0] pcout;
output [15:0] irout;
reg [15:0] pcout;
reg [15:0] irout;
reg [15:0] iroutsav;
reg saved;
reg flushprev;

initial
begin
#0
pcout=16'hfffe;
irout=16'h0000;
saved=0;
flushprev=0;
end

always
begin
@(posedge exflush)
$display("IfId Flush");
irout=16'h0000;
flushprev=1;
end

always
begin
@(negedge clk)
begin
#4
pcout=pc;
if ((saved==0)&&(flushprev==0)) irout=ir;

if ((saved==0)&&(flushprev==1))
	begin
	flushprev=0;
	irout=0;
	end

if(saved==1)
begin
$display("Fetched Saved inst. from LW stall");
saved=0;
irout=iroutsav;
end

$display("ifid: pcout %h, irout %h",pcout, irout);
end
end

always 
begin
#5
@(posedge freeze)
begin
iroutsav=irout;
irout=16'b000;
saved=1;
$display("Saved Instruction :%h",iroutsav);
end
end
endmodule


module pipeidex(clk, wb,wbout,m,mout,ex,exout,pc,pcout,rd1,rd1out,rd2,rd2out,sext,sextout,insta,instaout,instb,instbout,instc,instcout,idexinst,idexout,exflush);
input clk;

input [1:0] wb;
input [3:0] m;
input [3:0] ex;
input [15:0] pc;
input [15:0] rd1;
input [15:0] rd2;
input [15:0] sext;
input [2:0] insta;
input [2:0] instb;
input [2:0] instc,idexinst;
input exflush;

output [1:0] wbout;
output [3:0] mout;
output [3:0] exout;
output [15:0] pcout;
output [15:0] rd1out;
output [15:0] rd2out;
output [15:0] sextout;
output [2:0] instaout;
output [2:0] instbout;
output [2:0] instcout,idexout;

reg [1:0] wbout;
reg [3:0] mout;
reg [3:0] exout;
reg [15:0] pcout;
reg [15:0] rd1out;
reg [15:0] rd2out;
reg [15:0] sextout;
reg [2:0] instaout;
reg [2:0] instbout;
reg [2:0] instcout,idexout;

initial
begin
#0
wbout=2'b00;
mout=3'b000;
exout=4'b0000;
pcout=16'h0000;
rd1out=16'h0000;
rd2out=16'h0000;
sextout=16'h0000;
instaout=3'b000;
instbout=3'b000;
instcout=3'b000;
idexout=3'b000;
end

always
begin
@(posedge exflush)
$display("IdEx Flush");
wbout=3'b000;
mout=3'b000;
exout=4'b0000;
end

always
begin
@(negedge clk)
begin
#3
wbout=wb;
mout=m;
exout=ex;
pcout=pc;
rd1out=rd1;
rd2out=rd2;
sextout=sext;
instaout=insta;
instbout=instb;
instcout=instc;
idexout=idexinst;

$display("idex: wbout %h, mout %h, exout %h, pcout %h, rd1out %h, rd2out %h, sextout %h, instaout %h instbout %h instcout %h idexout %h",wbout, mout, exout, pcout, rd1out, rd2out, sextout, instaout, instbout, instcout,idexout);
end
end
endmodule


module pipeexmem(clk, wb,wbout,m,mout,pcadd,pcaddout,zero,zeroout,overflow, overout, alures,aluresout,rd2,rd2out,wd,wdout,rt,rtout,exflush);

input clk;

input [1:0] wb;
input [3:0] m;
input [15:0] pcadd;
input zero,overflow;
input [15:0] alures;
input [15:0] rd2;
input [2:0] wd;
input [2:0] rt;
input exflush;
 
output [1:0] wbout;
output [3:0] mout;
output [15:0] pcaddout;
output zeroout,overout;
output [15:0] aluresout;
output [15:0] rd2out;
output [2:0] wdout;
output [2:0] rtout;

reg [1:0] wbout;
reg [3:0] mout;
reg [15:0] pcaddout;
reg zeroout,overout;
reg [15:0] aluresout;
reg [15:0] rd2out;
reg [2:0] wdout;
reg [2:0] rtout;

initial
begin
#0
wbout=2'b00;
mout=3'b000;
pcaddout=16'h0000;
zeroout=0;
overout=0;
aluresout=16'h0000;
rd2out=16'h0000;
wdout=3'b000;
rtout=3'b000;
end

always
begin
@(posedge exflush)
$display("ExMem Flush");
wbout=3'b000;
mout[2:1]=2'b00;
end

always
begin
@(negedge clk)
begin
#2
wbout=wb;
mout=m;
pcaddout=pcadd;
zeroout=zero;
overout=overflow;
aluresout=alures;
rd2out=rd2;
wdout=wd;
rtout=rt;

$display("exmem: wbout %h, mout %h, pcaddout %h, zeroout %h, overout %h, aluresout %h, rd2out %h, wdout %h rtout %h",wbout, mout, pcaddout, zeroout, overout, aluresout, rd2out,wdout,rtout);
end
end

endmodule


module pipememwb(clk, wb,wbout,readdata,readdataout,aluresult,aluresultout,wd,wdout);
input clk;

input [1:0] wb;
input [15:0] readdata;
input [15:0] aluresult;
input [2:0] wd;

output [1:0] wbout;
output [15:0] readdataout;
output [15:0] aluresultout;
output [2:0] wdout;

reg [1:0] wbout;
reg [15:0] readdataout;
reg [15:0] aluresultout;
reg [2:0] wdout;

initial
begin
#0 wbout=2'b00;
readdataout=16'h0000;
aluresultout=16'h0000;
wdout=3'b000;
end


always
begin
@(negedge clk)
begin
#1
wbout=wb;
readdataout=readdata;
aluresultout=aluresult;
wdout=wd;

$display("memwb: wb %h, readdataout %h, aluresultout %h",wb,readdataout,aluresultout);
end
end

endmodule

// ----------------------------------------------------------------------------


//
// ALU Function Code Generator
//
module alucontrol(func, aluop, alucon, killoverflowz);

input [2:0] func;
input [1:0] aluop;
output [2:0] alucon;
reg [2:0] alucon;
output killoverflowz;
reg killoverflowz;

always
begin
#5
if(aluop==2'b00)
begin
alucon=3'b010;
killoverflowz=0;
end

if(aluop==2'b01)
begin
alucon=3'b110;
killoverflowz=0;
end

if(aluop==2'b10)
begin
alucon=func;
if((func==3'b010)||(func==3'b110))
begin
killoverflowz=1;
end
else
killoverflowz=0;
end

if((func==3'b011)&&(aluop==2'b10)) alucon=3'b010;	// addu fix...
 
end
endmodule


//
// Control Generator
//
module control(inst, func, wb, m, ex);
input [2:0] inst, func;

output [1:0] wb;
output [3:0] m;
output [3:0] ex;

reg [1:0] wb;
reg [3:0] m;
reg [3:0] ex;

always
begin

#5 
if(inst==3'b011)	// lw
begin
wb=2'b11;
m =4'b0010;
ex=4'b1000;
end

if(inst==3'b111)	// sw
begin
wb=2'b00;
m =4'b0100;
ex=4'b1000;
end

if(inst==3'b100)	// beq
begin
wb=2'b00;
m =4'b0001;
ex=4'b0010;
end

if(inst==3'b101)	// bne
begin
wb=2'b00;
m =4'b1000;
ex=4'b0010;
end

if((inst==3'b000)&&(func!=3'b101))	// r type
begin
wb=2'b01;
m =4'b0000;
ex=4'b0101;
end

if((inst==3'b000)&&(func==3'b101))	// shift
begin
wb=2'b01;
m =4'b0000;
ex=4'b0100;
end
end

endmodule


//
// fix up the pc on lw hazards (insert 1 cycle bubble in pc)
//
module pcfixup(pcout,pc,freeze,clk);
input [15:0] pc;
input freeze,clk;
output [15:0] pcout;
reg    [15:0] pcout;
reg	[15:0] bias;

initial
begin
#0 bias=0;
end

always 
begin
#1 pcout=pc+bias;
end

always
begin
@(posedge freeze)
bias=-2;
end

always
begin
@(negedge clk)
bias=0;
end

endmodule


//
// the datapath (last two signals are for testing *only*!)
//
module datapath(clk, pc,newpc,freeze,MEMDEBUG,REGDEBUG);
input clk;

input [15:0] pc;
output [15:0] newpc;
output freeze;

wire freeze;

wire [9:0] control2;
wire [2:0] alucontrol2;

reg [15:0] inst;
wire [15:0] ir;

initial
begin
#0 inst=0;
end

input MEMDEBUG,REGDEBUG;

wire carry16, overflow, zero;
wire [1:0] aluop;
wire [2:0] imux1;
wire [15:0] wdataval,rd1,rd2,sext,bmux,aluresult,alures2,readdata,dispshift,pca,pcb,pcc,jumppc;

wire [15:0] irPIfId;
wire [1:0] wbPMemWb;
wire [1:0] wbPExMem;
wire [1:0] wpPIdEx;
wire [3:0] exPIdEx;
wire [3:0] exIdEx;
wire [3:0] mPExMem;
wire [3:0] mPIdEx;
wire [15:0] sextPIdEx;
wire [2:0] rwbfinPMemWb, rwbfin, rwbfinPExMem, rwb0PIdEx, rwb1PIdEx, rwb2PIdEx,rwb1,rwb2,exmemrt,idexinst;
wire [15:0] rd1PIdEx, rd2PIdEx, rd2PExMem;
wire [15:0] alures, aluresPExMem, aluresPMemWb, readdataPMemWb, pcaPIdEx;
wire [15:0] alures2PExMem, pcaPIfId;
wire [1:0] cwb, wbPIdEx;
wire [3:0] cm;
wire [3:0] cex;
wire overflowout, killoverflowz, overflowfiltered,ovfiltz,freeze;

wire [1:0] alusela, aluselb;
wire [15:0] alua, alub,pc2;

wire pcselect,exflush,exflusha;
zero exf(exflusha);
assign exflush=pcselect;

rf		m0(clk,wbPMemWb[0],irPIfId[12:10],irPIfId[9:7], rwbfinPMemWb, wdataval, rd1, rd2,REGDEBUG);
mux3		m1(rwbfin,exPIdEx[0],rwb1PIdEx,rwb2PIdEx);
signextend	m2(sext,irPIfId[6:0]);
mux16		m3(bmux,exPIdEx[3],alub,sextPIdEx);
alu		m4(alures,carry16,overflow,alua,bmux,alucontrol2,zero,sextPIdEx[6:3]);
datamemory	m5(aluresPExMem,aluresPExMem,rd2PExMem,readdata,mPExMem[1],mPExMem[2],MEMDEBUG);
mux16		m6(wdataval,wbPMemWb[1],aluresPMemWb,readdataPMemWb);
shift1		m7(dispshift,sextPIdEx);
pcadd2		m8(pca,pc2);
pcadder		m9(alures2,pcaPIdEx,dispshift);
branch		m10(pcselect,mPExMem[0],mPExMem[3],zeroPExMem);
mux16		m11(newpc,pcselect,pca,alures2PExMem);
shift1		m13(pcc[15:0],jumppc[15:0]);
instmemory	m14(clk,pc,ir,MEMDEBUG);
control		m15(irPIfId[15:13],irPIfId[2:0],cwb, cm, cex);
alucontrol    	m16(sextPIdEx[2:0],exPIdEx[2:1],alucontrol2,killoverflowz);
ai2		m17(ovfiltz,killoverflowz,overflow);
i1		m18(overflowfiltered,ovfiltz);

forward		m19(alusela,aluselb,rwb0PIdEx,rwb1PIdEx,rwb2PIdEx,rwbfinPExMem,rwbfinPMemWb,wbPExMem[0],wbPMemWb[0],exmemrt);
alumux		m20(alua,alusela,rd1PIdEx,aluresPExMem,wdataval);
alumux		m21(alub,aluselb,rd2PIdEx,aluresPExMem,wdataval);
lwhaz		m22(freeze,idexinst,rwb1PIdEx,irPIfId[12:10],irPIfId[9:7]);
pcfixup		m23(pc2,pc,freeze,clk);

pipeifid	p0(clk, pc, pcaPIfId, ir, irPIfId,freeze,pcselect);
pipeidex	p1(clk, cwb, wbPIdEx, cm, mPIdEx, cex, exPIdEx, pcaPIfId, pcaPIdEx, rd1, rd1PIdEx,rd2, rd2PIdEx, sext, sextPIdEx, irPIfId[12:10],rwb0PIdEx, irPIfId[9:7], rwb1PIdEx, irPIfId[6:4], rwb2PIdEx, irPIfId[15:13],idexinst,pcselect);
pipeexmem	p2(clk, wbPIdEx, wbPExMem, mPIdEx, mPExMem, alures2, alures2PExMem, zero,zeroPExMem, overflowfiltered, overflowout, alures, aluresPExMem, alub, rd2PExMem, rwbfin, rwbfinPExMem, rwb1PIdEx, exmemrt,exflush);
pipememwb	p3(clk, wbPExMem, wbPMemWb, readdata, readdataPMemWb, aluresPExMem, aluresPMemWb,rwbfinPExMem, rwbfinPMemWb);

endmodule


//
// fast barrel shifter for sll..
//
module shifter(valout, valin, shcount);
output [15:0] valout;
input  [15:0] valin;
input  [3:0] shcount;

wire [15:0] sh1out,sh2out,sh3out,sh4out;
wire [15:0] lev1,lev2,lev3,lev4;

assign valout=lev4;

shift1 u1(sh1out,valin);
mux16 u2(lev1,shcount[0],valin,sh1out);

shift2 u3(sh2out,lev1);
mux16 u4(lev2,shcount[1],lev1,sh2out); 

shift4 u5(sh3out,lev2);
mux16 u6(lev3,shcount[2],lev2,sh3out); 

shift8 u7(sh4out,lev3);
mux16 u8(lev4,shcount[3],lev3,sh4out); 

endmodule

//
// shift by one
//
module shift1(shifted,orig);
output [15:0] shifted;
input  [15:0] orig;
 
assign shifted[15:1]=orig[14:0];
assign shifted[0]=0;
 
endmodule

//
// shift by two
//
module shift2(shifted,orig);
output [15:0] shifted;
input  [15:0] orig;
 
assign shifted[15:2]=orig[13:0];
assign shifted[1]=0;
assign shifted[0]=0;
 
endmodule

//
// shift by four
//
module shift4(shifted,orig);
output [15:0] shifted;
input  [15:0] orig;
 
assign shifted[15:4]=orig[11:0];
assign shifted[3]=0;
assign shifted[2]=0;
assign shifted[1]=0;
assign shifted[0]=0;
 
endmodule

//
// shift by eight
//
module shift8(shifted,orig);
output [15:0] shifted;
input  [15:0] orig;
 
assign shifted[15:8]=orig[7:0];
assign shifted[7]=0;
assign shifted[6]=0;
assign shifted[5]=0;
assign shifted[4]=0;
assign shifted[3]=0;
assign shifted[2]=0;
assign shifted[1]=0;
assign shifted[0]=0;
 
endmodule


//
// sign extender from 7 to 16 bits.
//
module signextend(val16, val7);

output [15:0] val16;
input  [6:0]  val7;

assign val16[6:0]=val7[6:0];
assign val16[7]=val7[6];
assign val16[8]=val7[6];
assign val16[9]=val7[6];
assign val16[10]=val7[6];
assign val16[11]=val7[6];
assign val16[12]=val7[6];
assign val16[13]=val7[6];
assign val16[14]=val7[6];
assign val16[15]=val7[6];

endmodule

//
// behavorial adder for the pc
//
module pcadder(newpc, value1, value2);
 
input [15:0] value1, value2;
output [15:0] newpc;
reg [15:0] newpc;
 
always
begin
#25     newpc=value1+value2;
end
 
endmodule
 
//
// behavorial add 2 to pc
//
module pcadd2(newpc,oldpc);
input [15:0] oldpc;
output [15:0] newpc;
reg [15:0] newpc;

always
begin
@(oldpc)
#25 
newpc=oldpc+2;
end

endmodule

//
// 3-bit mux... (s=0: y=a, s=1: y=b)
//
module mux3(y,s,a,b);
output [2:0] y;
input  [2:0] a,b;
input  s;

mux1 g0(y[0],s,a[0],b[0]);
mux1 g1(y[1],s,a[1],b[1]);
mux1 g2(y[2],s,a[2],b[2]);

endmodule


//
// 16-bit mux... (s=0: y=a, s=1: y=b)
//
module mux16(y,s,a,b);
output [15:0] y;
input  [15:0] a,b;
input  s;

mux1 g0(y[0],s,a[0],b[0]);
mux1 g1(y[1],s,a[1],b[1]);
mux1 g2(y[2],s,a[2],b[2]);
mux1 g3(y[3],s,a[3],b[3]);
mux1 g4(y[4],s,a[4],b[4]);
mux1 g5(y[5],s,a[5],b[5]);
mux1 g6(y[6],s,a[6],b[6]);
mux1 g7(y[7],s,a[7],b[7]);
mux1 g8(y[8],s,a[8],b[8]);
mux1 g9(y[9],s,a[9],b[9]);
mux1 ga(y[10],s,a[10],b[10]);
mux1 gb(y[11],s,a[11],b[11]);
mux1 gc(y[12],s,a[12],b[12]);
mux1 gd(y[13],s,a[13],b[13]);
mux1 ge(y[14],s,a[14],b[14]);
mux1 gf(y[15],s,a[15],b[15]);

endmodule

// 
// structural 1-bit mux
//
module mux1(y,s,a,b);
output y;
input  s;
input  a;
input  b;
 
i1 g0(n86,s);
aoi22 g1(n77,n86,a,s,b);
i1 g2(y,n77);
 
endmodule

//
// register file (8 words of 16-bits each)
//
module rf(clk,regwrite, rr1, rr2, wr, wd, rd1, rd2,REGDEBUG);
input clk;
input regwrite;
input [2:0] rr1;
input [2:0] rr2;
input [2:0] wr;
input [15:0] wd;
output [15:0] rd1;
output [15:0] rd2;

reg [15:0] rd1;
reg [15:0] rd2;
reg [15:0] register[0:7];

input REGDEBUG;

reg [4:0] i;			// index for clear routine.

initial
begin

#0 for(i=0;i<8;i=i+1)		// clear initial vals of regs to reg #
	begin			// so we have some scratch values..
	register[i]=i;
	end
end

always
begin
#1      if (clk)
        begin
	rd1=register[rr1];
	rd2=register[rr2];
	end
end

always
begin
	@(posedge clk);
	if ((regwrite)&&(wr!=0))// can't write to register zero
	begin
	#25 register[wr]=wd;
$display("WRITE: %h to register %d",register[wr],wr);
	end
end

always
begin
@(posedge REGDEBUG)
	begin
	#55
	$display("     reg: $0:%h $1:%h $2:%h $3:%h $4:%h $5:%h $6:%h $7:%h\n",
	register[0],register[1],register[2],register[3],register[4],
	register[5],register[6],register[7]);
	end
end

endmodule

//
// memory (32 words of 8-bits each)
//
module datamemory(readaddr,writeaddr,wd,rd,memread,memwrite,MEMDEBUG);
input [15:0] readaddr;
input [15:0] writeaddr;
input [15:0] wd;
output [15:0] rd;
reg [15:0] rd;
input memread;
input memwrite;
reg [7:0] memory[0:31];
reg [6:0] i;			// index for clear routine.

input MEMDEBUG;

initial
begin

#0 for(i=0;i<32;i=i+2)		// clear mem
	begin
	memory[i]=0;
	memory[i+1]=i;
	end
end

always
begin
#1	if (memread)
		begin
		#50
		rd[15:8]=memory[readaddr];
		rd[7:0]=memory[readaddr+1];
		end
	if (memwrite)
		begin
		#50
		memory[writeaddr]=wd[15:8];
		memory[writeaddr+1]=wd[7:0];
		end
end

always
begin
@(posedge MEMDEBUG)
	begin
	for(i=0;i<32;i=i+8)
	begin
	$display("(%h) dmem: %h %h %h %h %h %h %h %h",
	i, memory[i+0],memory[i+1],memory[i+2],memory[i+3],memory[i+4],
	memory[i+5],memory[i+6],memory[i+7]);
	end
	$display("");
	end
end

endmodule


//
// inst memory (64 words of 8-bits each)
//
module instmemory(clk, readaddr,rd,MEMDEBUG);
input clk;
input [15:0] readaddr;
output [15:0] rd;
reg [15:0] rd;
reg [7:0] memory[0:63];
reg [6:0] i;			// index for clear routine.

input MEMDEBUG;

initial
begin

#0 for(i=0;i<64;i=i+1)		// clear mem
	begin
	memory[i]=0;
	end

memory[0]=8'h05;
memory[1]=8'ha6;
memory[2]=8'h08;
memory[3]=8'h40;
memory[4]=8'h15;
memory[5]=8'h41;
memory[6]=8'h12;
memory[7]=8'h62;

end

always
begin
@(posedge clk)
#50		begin
		rd[15:8]=memory[readaddr];
		rd[7:0]=memory[readaddr+1];
		end
end

endmodule

//
// The 16-bit alu (from here to the end of the file is unchanged
// since the previous programming assignment)
//
module alu(muxedres,carry16,overflow,a,b,op,zeroflag,shamt);
output [15:0] muxedres;

wire [15:0] shiftres;
wire [15:0] result;

output carry16,overflow,zeroflag;
input [15:0] a;
input [15:0] b;
input [2:0] op;
input [3:0] shamt;
wire [15:0] c;
wire [3:0] cbig;
wire [15:0] bx;
wire ophigh,aluorshifter;

mux16 mx16shi(muxedres,aluorshifter,result,shiftres);
det101norm sd101(aluorshifter,op[2],op[1],op[0]);
shifter shi1(shiftres,a,shamt);

assign ophigh=op[2];	 // shorthand
assign carry16=c[15];  // get signal outside of module

zerodetect zdet0(zeroflag,result);

zero lesszero(less);

aluslc15 a15(result[15],less,a[15],b[15],bx[15],c[14],c[15],op,set,overflow);
aluslice a14(result[14],less,a[14],b[14],bx[14],c[13], op);
aluslice a13(result[13],less,a[13],b[13],bx[13],c[12], op);
aluslice a12(result[12],less,a[12],b[12],bx[12],c[11], op);
aluslice a11(result[11],less,a[11],b[11],bx[11],c[10], op);
aluslice a10(result[10],less,a[10],b[10],bx[10],c[9],  op);
aluslice a09(result[9], less,a[9], b[9], bx[9],c[8],  op);
aluslice a08(result[8], less,a[8], b[8], bx[8],c[7],  op);
aluslice a07(result[7], less,a[7], b[7], bx[7],c[6],  op);
aluslice a06(result[6], less,a[6], b[6], bx[6],c[5],  op);
aluslice a05(result[5], less,a[5], b[5], bx[5],c[4],  op);
aluslice a04(result[4], less,a[4], b[4], bx[4],c[3],  op);
aluslice a03(result[3], less,a[3], b[3], bx[3],c[2],  op);
aluslice a02(result[2], less,a[2], b[2], bx[2],c[1],  op);
aluslice a01(result[1], less,a[1], b[1], bx[1],c[0],  op);
aluslice a00(result[0], set, a[0], b[0], bx[0],ophigh, op);

xor2 b0(bx[0],b[0],ophigh);
xor2 b1(bx[1],b[1],ophigh);
xor2 b2(bx[2],b[2],ophigh);
xor2 b3(bx[3],b[3],ophigh);
xor2 b4(bx[4],b[4],ophigh);
xor2 b5(bx[5],b[5],ophigh);
xor2 b6(bx[6],b[6],ophigh);
xor2 b7(bx[7],b[7],ophigh);
xor2 b8(bx[8],b[8],ophigh);
xor2 b9(bx[9],b[9],ophigh);
xor2 b10(bx[10],b[10],ophigh);
xor2 b11(bx[11],b[11],ophigh);
xor2 b12(bx[12],b[12],ophigh);
xor2 b13(bx[13],b[13],ophigh);
xor2 b14(bx[14],b[14],ophigh);
xor2 b15(bx[15],b[15],ophigh);

carryunit04 c00(a[3:0]  ,bx[3:0],  op[2],c[3:0]);
carryunit04 c01(a[7:4]  ,bx[7:4],  c[3] ,c[7:4]);
carryunit04 c02(a[11:8] ,bx[11:8], c[7], c[11:8]);
carryunit04 c03(a[15:12],bx[15:12],c[11],c[15:12]);

endmodule


//
// ALU Slice for bit 15...
//
module aluslc15(result,less,a,b,bx,carryin,carrytop,op,set,overflow);

output result,set,overflow;
input less,a,b,bx,carryin,carrytop;
input [2:0] op;

det000z d0(sdet000z,op[2],op[1],op[0]);
det001z d1(sdet001z,op[2],op[1],op[0]);
det010z d2(sdet010z,op[2],op[1],op[0]);
det110z d6(sdet110z,op[2],op[1],op[0]);
det111z d7(sdet111z,op[2],op[1],op[0]);

xor2 ov(overflow,carryin,carrytop);

i1 i0(sltz,less);
i1 i1(set,addz);

oi2 o1(orz,a,b);		// or  for slice
ai2 a1(andz,a,b);		// and for slice
fulladder add1(addz,a,bx,carryin);

selaluout selalu(result,sdet000z,andz,sdet001z,orz,sdet010z,addz,sdet110z,addz,sdet111z,sltz);

endmodule


//
// Generic ALU slice for bits 0-14
//
module aluslice(result,less,a,b,bx,carryin,op);

output result;
input less,a,b,bx,carryin;
input [2:0] op;

det000z d0(sdet000z,op[2],op[1],op[0]);
det001z d1(sdet001z,op[2],op[1],op[0]);
det010z d2(sdet010z,op[2],op[1],op[0]);
det110z d6(sdet110z,op[2],op[1],op[0]);
det111z d7(sdet111z,op[2],op[1],op[0]);

i1 i0(sltz,less);
oi2 o1(orz,a,b);
ai2 a1(andz,a,b);
fulladder add1(addz,a,bx,carryin);

selaluout selalu(result,sdet000z,andz,sdet001z,orz,sdet010z,addz,sdet110z,addz,sdet111z,sltz);

endmodule


//
// Detect when zero is outputted by the ALU
//
module zerodetect(iszero,a);
input [15:0] a;
output iszero;

or4 zm1(t1,a[0],a[1],a[2],a[3]);
or4 zm2(t2,a[4],a[5],a[6],a[7]);
or4 zm3(t3,a[8],a[9],a[10],a[11]);
or4 zm4(t4,a[12],a[13],a[14],a[15]);

or4 zm9(t9,t1,t2,t3,t4);

i1 g01(iszero,t9);

endmodule


//
// Add, but carries are generated by an external cla unit
//
module fulladder(sum, ain, bin, cin);
output sum;
input ain, bin, cin;

xor2 xc1(x1,ain,bin);

i1  g01(t1,cin);
ai2 g02(t3,t1,x1);
i1  g03(t2,x1);
ai2 g04(t4,t2,cin);
i1  g05(t5,t3);
i1  g06(t6,t4);
oi2 g07(sum,t6,t5);

endmodule


//
// Detectors for each of the five ALU conditions
// Output is zero if xxx bit combination is detected
// else output is one.
//
module det000z(o,a,b,c);output o;input a,b,c;
oi2 g01(t1,a,b);	//can make this just a nand if we are looking
i1  g02(t2,c);		//only for x00.
ai2 g03(o,t1,t2);
endmodule

module det001z(o,a,b,c);output o;input a,b,c;
oi2 g01(t1,a,b);
ai2 g02(o,t1,c);
endmodule

module det010z(o,a,b,c);output o;input a,b,c;
oi2 g01(t1,a,c);
ai2 g02(o,t1,b);
endmodule

module det110z(o,a,b,c);output o;input a,b,c;
ai2 g01(t1,a,b);
oi2 g02(t2,t1,c);
i1  g03(o,t2);
endmodule

module det111z(o,a,b,c);output o;input a,b,c;
ai2 g01(t1,a,b);
i1  g02(t2,t1);
ai2 g03(o,t2,c);
endmodule

module det101norm(o,a,b,c);output o;input a,b,c;
ai2 g02(t1,a,c);
oi2 g03(o,t1,b);
endmodule

//
// Select ALU output based upon which detector is zero. 
// Note that the input value to mux comes in INVERTED.
//
module selaluout(o,det000z,andz,det001z,orz,det010z,addz,det110z,subz,det111z,sltz);
output o;
input det000z,andz,det001z,orz,det010z,addz,det110z,subz,det111z,sltz;

oi2 g01(t1,det000z,andz);
oi2 g02(t2,det001z,orz);
oi2 g03(t3,det010z,addz);
oi2 g04(t4,det110z,subz);
oi2 g05(t5,det111z,sltz);

oi2 g06(t6,t1,t2);
oi2 g07(t7,t3,t4);

i1  g08(t6i,t6);
i1  g09(t7i,t7);

oi2 g10(t8,t6i,t7i);
i1  g11(t8i,t8);

oi2 g12(t9,t8i,t5);
i1  g13(o,t9);

endmodule


//
// Four bit carry lookahead unit...
//
module carryunit04(a,b,cin,cout);
input [3:0] a;
input [3:0] b;
input cin;
output [3:0] cout;
 
    oai22 U5 (cout[2],n82,n83,n84,n85);		// synopsys generated..
    aoi22 U6 (n82,cout[0],a[1],n86,b[1]);
    aoi22 U7 (n87,n88,a[3],b[3],n89);
    ao5 U8 (n90,b[0],a[0],cin);
    ao5 U9 (n91,a[1],cout[0],b[1]);
    or2 U10 (n86,a[1],cout[0]);
    oi2 U11 (n84,a[2],cout[1]);
    oi2 U12 (n92,b[2],a[2]);
    oai22 U13 (n88,n85,n83,n91,n92);
    or2 U14 (n89,n88,a[3]);
    i1 U15 (n85,b[2]);
    i1 U16(n83,a[2]);
    i1 U17 (cout[1],n82);
    i1 U18(cout[3],n87);
    i1 U19(cout[0],n90);

endmodule


//
// mux select for beq/bne true
//
module branch(sel,a,b,c); // a=branch, b=branchneg, c=zero
output sel;
input  a,b,c;
 
wire n78;
assign sel=n78;
 
i1 g0(n90,c);
i1 g1(n92,b);
ai2 g2(n93,n92,a);
i1 g3(n91,a);
ai2 g4(n94,n91,b);
oai22 g5(n78,n90,n93,c,n94);
endmodule
 



//
// Gate library
//
module i1(o,a);input a;output o;assign #(1,1) o=!a;endmodule
module oi2(o,a,b);input a,b;output o;assign #(2,2) o=!(a|b);endmodule
 
module ai2(o,a,b);input a,b;output o;assign #(2,2) o=!(a&b);endmodule
module aoi22(o,a,b,c,d);input a,b,c,d;output o;assign #(2,2) o=!((a&b)|(c&d));endmodule
module aoi21(o,a,b,c);input a,b,c;output o;assign #(2,2) o=!((a|c)&(b|c));endmodule
module oai22(o,a,b,c,d);input a,b,c,d;output o;assign #(2,2) o=!((a|b)&(c|d));endmodule
module oai21(o,a,b,c);input a,b,c;output o;assign #(2,2) o=!((a&c)|(b&c));endmodule

module oi332(o,a,b,c);input a,b,c;output o;assign #(1,3) o=!(a|b|c);endmodule
module ai332(o,a,b,c);input a,b,c;output o;assign #(3,1) o=!(a&b&c);endmodule


//
// Emulation gates
//
module xor2(o,a,b);output o;input a,b;oi2 g01(t1,a,b);aoi21 g02(o,a,b,t1);endmodule
module or2(o,a,b);output o;input a,b;oi2 g01(t1,a,b);i1 g02(o,t1);endmodule
module or4(o,a,b,c,d);output o;input a,b,c,d;oi2 g01(t1,a,b);oi2 g02(t2,c,d);ai2 g03(o,t1,t2);endmodule
module ao5(o,a,b,c);output o;input a,b,c;aoi21 u1(t1,a,b,c);oi2 u2(t2,a,b);oi2 u3(t3,t1,t2);i1 u4(o,t3);endmodule

module one(o);output o;assign o=1;endmodule
module zero(o);output o;assign o=0;endmodule

